const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const ai_embeddings = sequelize.define(
    'ai_embeddings',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

vector_ref: {
        type: DataTypes.TEXT,
      
      

      },

dimensions: {
        type: DataTypes.INTEGER,
      
      

      },

embedding_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"image",


"text",


"face"

        ],

      },

quality_score: {
        type: DataTypes.DECIMAL,
      
      

      },

indexed_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  ai_embeddings.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































    db.ai_embeddings.hasMany(db.face_detections, {
      as: 'face_detections_face_embedding',
      foreignKey: {
          name: 'face_embeddingId',
      },
      constraints: false,
    });


    db.ai_embeddings.hasMany(db.selfie_references, {
      as: 'selfie_references_selfie_embedding',
      foreignKey: {
          name: 'selfie_embeddingId',
      },
      constraints: false,
    });










//end loop



    db.ai_embeddings.belongsTo(db.media_items, {
      as: 'media_item',
      foreignKey: {
        name: 'media_itemId',
      },
      constraints: false,
    });

    db.ai_embeddings.belongsTo(db.ai_models, {
      as: 'ai_model',
      foreignKey: {
        name: 'ai_modelId',
      },
      constraints: false,
    });

    db.ai_embeddings.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.ai_embeddings.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.ai_embeddings.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return ai_embeddings;
};


